unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TControl_Panel = class(TForm)
    Start_Button: TButton;
    StaticText10: TStaticText;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    Exit_Button: TButton;
    StaticText1: TStaticText;
    EditBoundX1: TEdit;
    EditBoundX2: TEdit;
    EditBoundY1: TEdit;
    EditBoundY2: TEdit;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    EditRov: TEdit;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    EditAlfa: TEdit;
    EditBeta: TEdit;
    StaticText7: TStaticText;
    EditD: TEdit;
    StaticText8: TStaticText;
    EditSegmX: TEdit;
    EditSegmY: TEdit;
    StaticText9: TStaticText;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    EditAlfaLight: TEdit;
    EditBetaLight: TEdit;
    StaticText13: TStaticText;
    StaticText17: TStaticText;
    procedure Plocha(Sender: TObject);
    procedure Exit(Sender: TObject);
    procedure SetY2(Sender: TObject);
    procedure SetDraw3D(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;
  DefSetX1,DefSetX2,DefSetY1,DefSetY2:Double;

implementation

uses Graph3D_2005;
Type TSurface = record
                A,B,C,D:T3DPoint;
                Shade  :Double;
                norm   :TVector;
                end;

var Surface :array [0..100,0..100] of TSurface;
{$R *.DFM}

procedure TControl_Panel.Plocha(Sender: TObject);
const RightRed=255;RightGreen=188;RightBlue=112;
      WrongRed=143;WrongGreen=235;WrongBlue=255;

var Code,i,j,m,n  :Integer;
    Alfa,Beta,Direct  :Double;
    f,ErrorReport:String;
    Condition   :Boolean;
    SegmX,SegmY :Integer;
    u,v,w       :TVector;
    RedA,GreenA,BlueA,
    RedB,GreenB,BlueB,
    RedC,GreenC,BlueC,
    RedD,GreenD,BlueD  :byte;
    Expression  :TExpression;

  Procedure Setting;
  var numer:Real;
  begin
    Val(EditX1.Text,Numer,Code);Draw3D.X1:=Numer;
    Val(EditX2.Text,Numer,Code);Draw3D.X2:=Numer;
    Val(EditY1.Text,Numer,Code);Draw3D.Y1:=Numer;
    Val(EditY2.Text,Numer,Code);Draw3D.Y2:=Numer;
    Val(EditSegmX.Text,Numer,Code);SegmX:=Trunc(Numer);
    Val(EditSegmY.Text,Numer,Code);SegmY:=Trunc(Numer);
    Val(EditBoundX1.Text,Numer,Code);DefSetX1:=Numer;
    Val(EditBoundX2.Text,Numer,Code);DefSetX2:=Numer;
    Val(EditBoundY1.Text,Numer,Code);DefSetY1:=Numer;
    Val(EditBoundY2.Text,Numer,Code);DefSetY2:=Numer;
    Val(EditAlfa.Text,Alfa,Code);
    Val(EditBeta.Text,Beta,Code);
    Val(EditAlfaLight.Text,Draw3D.AlfaLight,Code);
    Val(EditBetaLight.Text,Draw3D.BetaLight,Code);
    Val(EditD.Text,Draw3D.ObserverDistance,Code);
    f:=EditRov.Text;
  end;  {Setting}

  begin
    Setting;
    With Draw3D do
    begin
       Visible:=True;ClearImage(255,255,230);
       Scale(x1,x2,y1,y2);
       SetCenterProjection(Alfa,Beta,ObserverDistance,ObserverPoint);
       SetDirectOfLight(AlfaLight,BetaLight,DirectOfLight);
    end;
    Draw3D.hx:=(DefSetx2-DefSetx1)/SegmX;Draw3D.hy:=(DefSety2-DefSety1)/SegmY;

    {*** constant shading ***}

      With Draw3D do
      begin hx:=(DefSetx2-DefSetx1)/SegmX;hy:=(DefSety2-DefSety1)/SegmY;
      Expression:=PreCalc(f,ErrorReport);
      if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
      y:=DefSety1;
      Repeat
         x:=DefSetx1;
         Repeat
         A[1]:=x;A[2]:=y;
         A[3]:=PostCalc(Expression,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         x:=x+hx;
         B[1]:=x;B[2]:=y;
         B[3]:=PostCalc(Expression,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         y:=y+hy;
         C[1]:=x;C[2]:=y;
         C[3]:=PostCalc(Expression,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         x:=x-hx;
         D[1]:=x;D[2]:=y;
         D[3]:=PostCalc(Expression,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         SetVector(B,C,u);SetVector(B,A,v);VectorProduct(u,v,w);
         SetVector(B,ObserverPoint,u);
         Direct:=CosAngle(u,w);
         if Direct>0
               then begin Red:=WrongRed;Green:=WrongGreen;Blue:=WrongBlue;end
               else begin Red:=RightRed;Green:=RightGreen;Blue:=RightBlue;end;
         Direct:=CosAngle(w,DirectOfLight);
         if ((Direct>0) and (Red=WrongRed)) or
            ((Direct<0) and (Red=RightRed))
               then begin
                     Red:=Trunc(abs(Direct)*Red);
                     Green:=Trunc(abs(Direct)*Green);
                     Blue:=Trunc(abs(Direct)*Blue);
                    end
               else begin Red:=0;Green:=0;Blue:=0;
                    end;

         FillTriangle(A,B,C,Red,Green,Blue);
         FillTriangle(C,D,A,Red,Green,Blue);
         y:=y-hy;x:=x+hx;
         until x>DefSetx2;
        y:=y+hy;
        Image.Repaint;
        Application.ProcessMessages;
      until y>DefSety2;

    Sleep(1000);

    {**** interpol shading *****}

    y:=DefSety1;j:=0;
      Repeat
         x:=DefSetx1;i:=0;
         Repeat
         Surface[i,j].A[1]:=x;Surface[i,j].A[2]:=y;
         Surface[i,j].A[3]:=PostCalc(Expression,ErrorReport);
         x:=x+hx;
         Surface[i,j].B[1]:=x;Surface[i,j].B[2]:=y;
         Surface[i,j].B[3]:=PostCalc(Expression,ErrorReport);
         y:=y+hy;
         Surface[i,j].C[1]:=x;Surface[i,j].C[2]:=y;
         Surface[i,j].C[3]:=PostCalc(Expression,ErrorReport);
         x:=x-hx;
         Surface[i,j].D[1]:=x;Surface[i,j].D[2]:=y;
         Surface[i,j].D[3]:=PostCalc(Expression,ErrorReport);
         SetVector(Surface[i,j].B,Surface[i,j].C,u);
         SetVector(Surface[i,j].B,Surface[i,j].A,v);VectorProduct(u,v,w);
         SetVector(Surface[i,j].B,ObserverPoint,u);
         Surface[i,j].Shade:=CosAngle(u,w);
         Surface[i,j].norm:=w;
         y:=y-hy;x:=x+hx;inc(i);
         until x>DefSetx2+hx;
        y:=y+hy;inc(j);
        Image.Repaint;
        Application.ProcessMessages;
      until y>DefSety2;
      end;
      m:=i-1;n:=j-1;
      for j:=0 to n-1 do
      begin
        for i:=0 to m-1 do
        With Draw3D do
        begin
          if Surface[i,j].Shade>0
               then begin Red:=WrongRed;Green:=WrongGreen;Blue:=WrongBlue;end
               else begin Red:=RightRed;Green:=RightGreen;Blue:=RightBlue;end;

         Direct:=CosAngle(Surface[i,j].norm,DirectOfLight);
         if ((Direct>0) and (Red=WrongRed)) or
            ((Direct<0) and (Red=RightRed))
               then begin
                     RedA:=Trunc(abs(Direct)*Red);
                     GreenA:=Trunc(abs(Direct)*Green);
                     BlueA:=Trunc(abs(Direct)*Blue);
                    end
               else begin RedA:=0;GreenA:=0;BlueA:=0;
                    end;

         Direct:=CosAngle(Surface[succ(i),j].norm,DirectOfLight);
         if ((Direct>0) and (Red=WrongRed)) or
            ((Direct<0) and (Red=RightRed))
               then begin
                     RedB:=Trunc(abs(Direct)*Red);
                     GreenB:=Trunc(abs(Direct)*Green);
                     BlueB:=Trunc(abs(Direct)*Blue);
                    end
               else begin RedB:=0;GreenB:=0;BlueB:=0;
                    end;

         Direct:=CosAngle(Surface[succ(i),succ(j)].norm,DirectOfLight);
         if ((Direct>0) and (Red=WrongRed)) or
            ((Direct<0) and (Red=RightRed))
               then begin
                     RedC:=Trunc(abs(Direct)*Red);
                     GreenC:=Trunc(abs(Direct)*Green);
                     BlueC:=Trunc(abs(Direct)*Blue);
                    end
               else begin RedC:=0;GreenC:=0;BlueC:=0;
                    end;

         Direct:=CosAngle(Surface[i,succ(j)].norm,DirectOfLight);
         if ((Direct>0) and (Red=WrongRed)) or
            ((Direct<0) and (Red=RightRed))
               then begin
                     RedD:=Trunc(abs(Direct)*Red);
                     GreenD:=Trunc(abs(Direct)*Green);
                     BlueD:=Trunc(abs(Direct)*Blue);
                    end
               else begin RedD:=0;GreenD:=0;BlueD:=0;
                    end;

         FillInterpolTriangle(Surface[i,j].A,Surface[i,j].B,Surface[i,j].C,
                     RedA,GreenA,BlueA,RedB,GreenB,BlueB,RedC,GreenC,BlueC);
         FillInterpolTriangle(Surface[i,j].C,Surface[i,j].D,Surface[i,j].A,
                     RedC,GreenC,BlueC,RedD,GreenD,BlueD,RedA,GreenA,BlueA);
        end;
        Draw3D.Image.Repaint;
      end;
    end;

procedure TControl_Panel.Exit(Sender: TObject);
begin
  Draw3D.Visible:=False;
  Halt;
end;


procedure TControl_Panel.SetY2(Sender: TObject);
var x1,x2,y1,y2:Real;
    Code:Integer;
    Vypis:String;
begin
   With Draw3D do
   begin
   Val(EditX1.Text,x1,Code);
   Val(EditX2.Text,x2,Code);
   Val(EditY1.Text,y1,Code);
   y2:=y1+(x2-x1)*ClientHeight/ClientWidth;
   Str(y2:4:2,Vypis);EditY2.Text:=Vypis;
   EditY2.Show;
   end;
end;

procedure TControl_Panel.SetDraw3D(Sender: TObject);
begin
  Application.CreateForm(TDraw3D, Draw3D);
  With Draw3D do
  begin
    ClientWidth:=500;ClientHeight:=500;
    InitImage(500,500);InitMemoryImage(500,500);
    Top:=40;Left:=380;
    Caption:='z=f(x,y) - Shade Interpolation';
    Visible:=True;
  end;
end;



end.
